import pygame

from ..Items import Screen
from ..Mods import modBase


class Image:
    def __init__(self, screen: Screen, path, xy, wh=None):
        self.mods = {}
        self.screen = screen
        screen.Items.append(self)
        self.xy = xy

        self.img = pygame.image.load(path)
        if wh:
            self.img = pygame.transform.scale(self.img, wh)

        self.rect = self.img.get_rect()

    def config(self, path, xy, wh=None):
        self.xy = xy

        self.img = pygame.image.load(path)
        if wh:
            self.img = pygame.transform.scale(self.img, wh)

        self.rect = self.img.get_rect()

    def addMod(self, mod: modBase):
        if mod.name not in self.mods:
            self.mods[mod.name] = mod

    def update(self):
        self.screen.root.MainRoot.blit(self.img, self.xy)